package edu.stanford.nlp.objectbank;

import java.io.Reader;
import edu.stanford.nlp.process.Tokenizer;

/** A TokenizerFactory is used to convert a java.io.Reader
 *  into a Tokenizer (or an Iterator) over the Objects represented by the text
 *  in the java.io.Reader.  It's mainly a convenience, since you could cast
 *  down anyway.
 *
 *  @author Christopher Manning
 */
public interface TokenizerFactory extends IteratorFromReaderFactory {

    public Tokenizer getTokenizer (Reader r);

}
