package edu.stanford.nlp.parser.lexparser;

import java.util.*;
import edu.stanford.nlp.trees.*;
import edu.stanford.nlp.util.*;

/** A lexicon class for German.  Extends the current Lexicon class,
 *  overriding its score and train methods to include a
 *  GermanUnknownWordModel.
 * @author Roger Levy
 */
class GermanLexicon extends Lexicon {
  GermanUnknownWordModel unknown = new GermanUnknownWordModel();

  /* trains on a collection of trees */
  public void train(Collection trees) {
    super.train(trees);
    unknown.train(trees);
  }

  public double score(IntTaggedWord iTW, int loc) {

    double c_W = seenCounter.getCount(iTW);

    boolean seen = (c_W > 0.0);

    if(seen) {
      return super.score(iTW, loc);
    }
    else
      return unknown.score(iTW);
  }

  private static long serialVersionUID = 221L;

}
