package edu.stanford.nlp.parser.lexparser;

import java.io.Serializable;
import java.util.Map;

/** Stores the serialized material for a parser */
public class ParserData implements Serializable {

  Lexicon lex;
  BinaryGrammar bg;
  UnaryGrammar ug;
  DependencyGrammar dg;
  Map numbs;
  Options pt;

  public ParserData(Lexicon lex, BinaryGrammar bg, UnaryGrammar ug,
                    DependencyGrammar dg, Map numbs, Options pt) {
    this.lex = lex;
    this.bg = bg;
    this.ug = ug;
    this.dg = dg;
    this.numbs = numbs;
    this.pt = pt;
  }

  private static final long serialVersionUID = 1;

}
