package edu.stanford.nlp.parser.lexparser;

import edu.stanford.nlp.process.Function;
import edu.stanford.nlp.trees.TreeTransformer;
import edu.stanford.nlp.trees.LeftHeadFinder;
import edu.stanford.nlp.trees.Tree;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
/**
 * @author Kristina Toutanova (kristina@cs.stanford.edu)
 * The purpose of this class is to do the necessary transformations to parse trees
 * read off the treebank, so that they can be passed to a <code>DependencyGrammarExtractor</code>
 */
public class TransformTreeDependency implements Function{
     TreeTransformer binarizer = null;
     public TransformTreeDependency(TreebankLangParserParams tlpParams){
        if (!Train.leftToRight) {
         binarizer = BinarizerFactory.getHeadRespectingBinarizer(tlpParams.headFinder(), !Train.outsideFactor());
         } else {
             binarizer = BinarizerFactory.getHeadRespectingBinarizer(new LeftHeadFinder(), !Train.outsideFactor());
         }
     }


    public Object apply(Object in) {
        Tree tree = (Tree) in;
	
         if (Train.hSelSplit) {
            ((BinarizerFactory.TreeAnnotatorAndBinarizer) binarizer).setCountStates(true);
         if (Train.collinsPunc)
          tree = CollinsPuncTransformer.transformTree(tree);
        binarizer.transformTree(tree, null);
      ((BinarizerFactory.TreeAnnotatorAndBinarizer) binarizer).setCountStates(false);
    }

      if (Train.collinsPunc)
        tree = CollinsPuncTransformer.transformTree(tree);
      tree = binarizer.transformTree(tree, null);
      return tree;
    }

}
