package edu.stanford.nlp.process;

import edu.stanford.nlp.trees.Word;

/**
 * <code>Processor</code> whose <code>process</code> method converts a 
 * collection of mixed-case Words to a collection of lowercase Words. 
 *
 * @author Sepandar Kamvar (sdkamvar@stanford.edu)
 */

public class LowercaseProcessor extends FunctionProcessor {

    public LowercaseProcessor() {
	super(new LowercaseFunction());
    }

}


/**
 * Takes a Word and returns a lowercase version of the Word.
 */
class LowercaseFunction implements Function {

    /**
     * Lowercases the Word coming in
     */
    public Object apply(Object in) {
	return(new Word(((Word)in).word().toLowerCase()));
    }

}
