package edu.stanford.nlp.trees;

/** An individual dependency.  Skeleton of a class.  Needs some fleshing out.
 *  @author Christopher Manning
 */
public class Dependency {

    private Label head;
    private Label dependent;
    private int   index;

    public int hashCode() {
      return head.hashCode() ^ dependent.hashCode() ^ index;
    }

    public boolean equals(Object o) {
      if (this == o)
        return true;
      if (o instanceof Dependency) {
        Dependency d = (Dependency) o;
        return index == d.index && head.equals(d.head) && 
	    dependent.equals(d.dependent);
      }
      return false;
    }

    public String toString() {
	if (index < 0) {
	    return dependent + " <-" + (-index) + "- " + head;
	} else {
	    return head + " -" + index + "-> " + dependent;
	}
    }

    public Dependency(String head, String dependent) {
	this(new StringLabel(head), new StringLabel(dependent));
    }

    public Dependency(Label head, Label dependent) {
	this(head, dependent, 0);
    }

    public Dependency(Label head, Label dependent, int index) {
      this.head = head;
      this.dependent = dependent;
      this.index = index;
    }

}
