package edu.stanford.nlp.trees.international.negra;

import edu.stanford.nlp.trees.*;
import java.util.*;

/* An object for edge labels as implemented in the Negra treebank.
 * Negra labels need a CATEGORY, an EDGE LABEL, and a MORPHOLOGICAL
 * INFORMATION value.  There is a different object for lexicalized
 * Negra labels.
 *
 * @author Roger Levy
 */

public class NegraLabel extends Category implements Label,HasCategory {

  private String edge = null; //get+set
  private Map features = new HashMap();

  public void setEdge(String edge) {
    this.edge = edge;
  }

  public String getEdge() {
    return edge;
  }

  public NegraLabel() {
  }

  public NegraLabel(String str) {
    super(str);
  }

  public void setFeatureValue(String feature, String value) {
    features.put(feature,value);
  }

  public String featureValue(String feature) {
    return (String) features.get(feature);
  }


  public String toString() {
    String str = value();
    if(edge != null)
      str += "->" + getEdge();
    str += "." + features.toString();
    return str;
  }


}
