package edu.stanford.nlp.trees.international.negra;

import edu.stanford.nlp.io.*;
import java.io.*;

/** Produces a tokenizer for the NEGRA corpus in context-free Penn
 * Treebank format.
 * @author Roger Levy
 */
public class NegraPennTokenizer extends AbstractStreamTokenizer {
  public NegraPennTokenizer(Reader r) {
    super(new NegraPennLexer(r));
  }


  public static void main(String[] args) throws IOException {
    
    Reader in = new FileReader(args[0]);
    
    edu.stanford.nlp.io.StreamTokenizer st = new NegraPennTokenizer(in);
    
    String s;
    while ((s = st.next()) != null) {
      System.out.println(s);
    }
    
  }
  

}
