package edu.stanford.nlp.util;

import java.util.List;
import java.util.Arrays;

/**
 * @author Dan Klein
 */
public class Characters {
    static Character[] canonicalCharacters = null;

    public static Character getCharacter(char c) {
        if (canonicalCharacters == null) {
            canonicalCharacters = new Character[65536];
        }
        Character cC = canonicalCharacters[(int) c];
        if (cC == null) {
            cC = new Character(c);
            canonicalCharacters[(int) c] = cC;
        }
        return cC;
    }

    public static Character[] asCharacterArray(String s) {
        Character[] split = new Character[s.length()];
        for (int i = 0; i < split.length; i++)
            split[i] = getCharacter(s.charAt(i));
        return split;
    }

  public static List asCharacterList(String s) {
    return Arrays.asList(asCharacterArray(s));
  }
}
