package edu.stanford.nlp.util;

/** A Counter that is maintained as a delta off another Counter.
 *  This will be efficient if you are maintaining minor modifications to 
 *  Counters.
 *  @author Teg Grenager
 *  Date: Jan 26, 2004
 *  Time: 8:39:49 PM
 */
public class DeltaCounter extends Counter {

  /**
   * puts new MutableDoubles.
   */
  public void setCount(Object key, double count) {
    MutableDouble newMD = new MutableDouble(count);
    map.put(key, newMD);
  }

  /**
   * puts new MutableDoubles.
   */
  public void incrementCount(Object key, double count) {
    MutableDouble oldMD = (MutableDouble) map.get(key);
    if (oldMD != null)
      count += oldMD.doubleValue();
    MutableDouble newMD = new MutableDouble(count);
    map.put(key, newMD);
  }


  public DeltaCounter(Counter c) {
    this.mapFactory = c.mapFactory;
    this.map = new DeltaMap(c.map, mapFactory);
  }

}
