package edu.stanford.nlp.util;

/**
 * User: Teg Grenager
 * Date: Feb 20, 2004
 * Time: 9:44:12 AM
 */
public class Triple {
  public Object first;
  public Object second;
  public Object third;

  public boolean equals(Object o) {
    if (this == o) return true;
    if (!(o instanceof Triple)) return false;

    final Triple triple = (Triple) o;

    if (first != null ? !first.equals(triple.first) : triple.first != null) return false;
    if (second != null ? !second.equals(triple.second) : triple.second != null) return false;
    if (third != null ? !third.equals(triple.third) : triple.third != null) return false;

    return true;
  }

  public int hashCode() {
    int result;
    result = (first != null ? first.hashCode() : 0);
    result = 29 * result + (second != null ? second.hashCode() : 0);
    result = 29 * result + (third != null ? third.hashCode() : 0);
    return result;
  }

  public Triple(Object first, Object second, Object third) {
    this.first = first;
    this.second = second;
    this.third = third;
  }
}
